/*
    Copyright 2004,2005,2006 Luigi Auriemma

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA

    http://www.gnu.org/licenses/gpl.txt

*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/stat.h>



#define VER         "0.1"
#define PW          "EPw\0"
#define SCRIBEDATA  "KLWEHGF)AS^*_GPYIOShakl;sjfhas0w89725l3jkhL:KHASFQ_DF_AS+_F"

#ifndef u_char
    #define u_char  unsigned char
#endif



void scribe_pwd(u_char *pwd, int len);
void std_err(void);



int main(int argc, char *argv[]) {
    FILE        *fd;
    u_char      *buff,
                *title,
                *ptr,
                *limit;
    int         size;
    struct stat xstat;


    setbuf(stdout, NULL);

    fputs("\n"
        "i.Scribe passwords decoder "VER"\n"
        "by Luigi Auriemma\n"
        "e-mail: aluigi@autistici.org\n"
        "web:    aluigi.org\n"
        "\n", stdout);

    if(argc < 2) {
        printf("\nUsage: %s <scribe.r>\n"
            "\n", argv[0]);
        fputs("\n    Press RETURN to exit\n", stdout);
        fgetc(stdin);
        exit(1);
    }

    printf("\nOpening file %s\n", argv[1]);
    fd = fopen(argv[1], "rb");
    if(!fd) std_err();

    fstat(fileno(fd), &xstat);

    buff = malloc(xstat.st_size);
    if(!buff) std_err();

    limit = buff + xstat.st_size;

    fread(buff, xstat.st_size, 1, fd);
    fclose(fd);

    for(ptr = buff; ptr < limit; ptr++) {
        if(!memcmp(ptr, PW, sizeof(PW) - 1)) {
            for(title = ptr; *title; title--);
            printf("\n%s:   ", title + 1);

            ptr += (sizeof(PW) - 1) + 4;
            size = *(int *)ptr;
            ptr += 4;
            scribe_pwd(ptr, size);
            printf("%s\n", ptr);
        }
    }

    fputs("\n    Press RETURN to exit\n", stdout);
    fgetc(stdin);
    return(0);
}



void scribe_pwd(u_char *pwd, int len) {
    u_char  *enc;

    enc = SCRIBEDATA;
    while(len--) {
        *pwd++ ^= *enc++;
        if(!*enc) enc = SCRIBEDATA;
    }
    *pwd = 0;
}



void std_err(void) {
    perror("\nError");
    fputs("\n    Press RETURN to exit\n", stdout);
    fgetc(stdin);
    exit(1);
}


